//============================================================================
//	apci8375s.pas
//
//	aPCI-8375
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/10/21
//
//	Tv
//		̿ɂׯ߰֐̎gpႪLqĂ܂B
//		aPCI-8375{[h̐ݒ͈ȉ̂悤ȐݒƂ܂B
//			EVXeAhX32_
//			EI/OݒXCb`͑SONíj
//		ڑjbg̐ݒ
//			Eo̓jbgi16_j̐擪AhX 0h Ƃ܂B
//			E̓jbgi16_j̐擪AhX 10h Ƃ܂B
//
//============================================================================
unit apci8375s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci8375w;

const
	szTitle		= 'Sample';
	szSLPCI		= 'aPCI-8375';
	WAIT_TIME	= 200;
	SET_IOS		= $01;

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wBsn: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
	wBsn:			Word;							// ޲BSNi[
	dwDLLVer, dwDriverVer: DWord;
	szBuf:		AnsiString;
	dwFlags, dwERR4Units: DWord;
	dwUnits:	DWord;
	Complete:	BOOL;
	dwLength:	DWord;
	dwIOs:		DWord;
	dwSlAddress, dwData: DWord;
	Connected, Active: BOOL;
	Status:		BOOL;
begin
	//-------------------------------------------------
	// apci8375.dll ̎gp錾
	//-------------------------------------------------
	if Apci8375wDllOpen() = False then begin
		ErrorMessage(APCI8375_BSN_AUTO);
		Exit;											// apci8375.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-8375 DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Apci8375wGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(APCI8375_BSN_AUTO);
		Exit;
	end;
	szBuf := Format('GetVersion'#10 +
									'DLL Version'#09+ ': %08xH'#10 +
									'Driver Version'#09+ ': %08xH'
									,[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375̎gp錾
	//-------------------------------------------------
	wBsn := APCI8375_BSN_AUTO;					// gp޲T܂B
	if Apci8375wCreate(wBsn) = False then begin	// ꍇA̎޲BSNi[܂B
		ErrorMessage(APCI8375_BSN_AUTO);	// ޲܂B
		Exit;
	end;
	szBuf := Format('aPCI-8375 Created'#10#10 + 'Board Select No.: %02XH', [wBsn]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375̼Ѿ
	//-------------------------------------------------
	if Apci8375wSystemSet(wBsn) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	ResultMessage('System Set');
	//-------------------------------------------------
	// aPCI-8375̏Ԏ擾
	//-------------------------------------------------
	if Apci8375wGetErrorFlags(wBsn, dwFlags, dwERR4Units) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Apci8375wGetTotalUnitNumber(wBsn, dwUnits, Complete) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Apci8375wSystemAddressLength(wBsn, dwLength) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	szBuf := Format('Board Name'#09  + ': %s'#10 +
									'Error Flags'#09 + ': %02XH'#10 +
									'ER4 Units '#09  + ': %d'#10 +
									'Total Unit Number'#09+ ': %2d'#10 +
									'System Address Length: %d'
									,[szSLPCI, dwFlags, dwERR4Units,
									 dwUnits, dwLength]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375̒ʐM
	//-------------------------------------------------
	if Apci8375wGetCommStatus(wBsn, Status) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Status = True then
		szBuf := 'Com. Status : GOOD'
	else
		szBuf := 'Com. Status : BAD';

	ResultMessage(szBuf);
	//-------------------------------------------------
	// BS1A
	//-------------------------------------------------
	szBuf := 'BS1A Status'#10;
	for dwSlAddress := 0 to 6 do begin
		if Apci8375wGetBS1AStatus(wBsn, dwSlAddress, Connected, Active) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
		szBuf := szBuf + Format('Address %d: ', [ dwSlAddress ]);
		if Connected = True then
			szBuf := szBuf + 'Connection=ON  '
		else
			szBuf := szBuf + 'Connection=OFF ';

		if Active = True then
			szBuf := szBuf + 'Active=GOOD '#10
		else
			szBuf := szBuf + 'Active=BAD  '#10;

	end;
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375̏ݒ
	//-------------------------------------------------
	if Apci8375wSetWaitTime(wBsn, WAIT_TIME) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Apci8375wSetIOs(wBsn, SET_IOS) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Apci8375wGetIOs(wBsn, dwIOs) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	if Apci8375wBankChange(wBsn, 0) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	szBuf := Format('Set Wait Time'	+ ': %dms'#10 +
									'Set IOs'#09		+ ': %02XH'#10 +
									'Get IOs'#09		+ ': %02XH'#10 +
									'Bank'#09				+ ': 0'
									,[ WAIT_TIME, SET_IOS, dwIOs ]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// S-LINKAhX 0 ` 15 SON
	//-------------------------------------------------
	for dwSlAddress := 0 to 15 do begin
		if Apci8375wOutBit(wBsn, dwSlAddress, True, APCI8375_ACT_FRAME_CHECK) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
	end;
	ResultMessage('S-LINK Address 0 - 15 All ON');
	//-------------------------------------------------
	// S-LINKAhX 0 ` 31 ǂݏo
	//-------------------------------------------------
	szBuf := 'S-LINK Address 0 - 31 I/O'#10;
	for dwSlAddress := 0 to 31 do begin
		if Apci8375wInBit(wBsn, dwSlAddress, Status) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
		if True = Status then
			szBuf := szBuf + Format('Address %2d'#09	+ ': ON'#10, [ dwSlAddress ])
		else
			szBuf := szBuf + Format('Address %2d'#09	+ ': OFF'#10, [ dwSlAddress ]);
	end;

	ResultMessage(szBuf);
	//-------------------------------------------------
	// S-LINK޲ıڽ 0 ` 1 SOFF
	//-------------------------------------------------
	for dwSlAddress := 0 to 1 do begin
		if Apci8375wOutByte(wBsn, dwSlAddress, 0, APCI8375_ACT_FRAME_CHECK) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
	end;
	ResultMessage('S-LINK Byte Address 0 - 1 All OFF');
	//-------------------------------------------------
	// S-LINK޲ıڽ 0 ` 3 ǂݏo
	//-------------------------------------------------
	szBuf := 'S-LINK Byte Address 0 - 3 I/O'#10;
	for dwSlAddress := 0 to 3 do begin
		if Apci8375wInByte(wBsn, dwSlAddress, dwData) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
		szBuf := szBuf + Format('Byte Address %2d'#09	+ ': %2XH'#10, [ dwSlAddress, dwData ])
	end;
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375Bank2
	//(Apci8375wReadStatusArea, Apci8375wWriteStatusAreaݸ؂ւƓ)
	//-------------------------------------------------
	if Apci8375wWriteStatusArea(wBsn, $14, 2) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	repeat
		if Apci8375wReadStatusArea(wBsn, $15, dwData) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
	until dwData = 2;
	szBuf := 'Bank2 : '#10;
	for dwSlAddress := 0 to 3 do begin
		if Apci8375wInByte(wBsn, dwSlAddress, dwData) = False then begin
			ErrorMessage(wBsn);
			Exit;
		end;
		szBuf := szBuf + Format('Byte Address %2d'#09	+ ': %2XH'#10, [ dwSlAddress, dwData ])
	end;
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-8375̎gpJ
	//-------------------------------------------------
	if Apci8375wClose(wBsn) = False then begin
		ErrorMessage(wBsn);
		Exit;
	end;
	ResultMessage('aPCI-8375 Closed');
	//-------------------------------------------------
	// apci8375.dll ̎gpJ
	//-------------------------------------------------
	if Apci8375wDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wBsn: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Apci8375wGetLastError(wBsn);
	case dwRes of
		APCI8375_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08XH', [GetLastError()]);
		APCI8375_ERR_WRAPDLL:
    	szBuf := 'DLL Load error';
		else
			szBuf := Format('aPCI-8375 error'#10#10'Error code: %08XH',[dwRes]);
  end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.


