/*============================================================================
//	apci8375w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/10/21
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci8375w.h"

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci8375wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci8375GetVersion = NULL;
static FARPROC pApci8375Create = NULL;
static FARPROC pApci8375SetWaitTime = NULL;
static FARPROC pApci8375SetIOs = NULL;
static FARPROC pApci8375GetIOs = NULL;
static FARPROC pApci8375SystemSet = NULL;
static FARPROC pApci8375GetTotalUnitNumber = NULL;
static FARPROC pApci8375SystemAddressLength = NULL;
static FARPROC pApci8375InBit = NULL;
static FARPROC pApci8375OutBit = NULL;
static FARPROC pApci8375InByte = NULL;
static FARPROC pApci8375OutByte = NULL;
static FARPROC pApci8375Close = NULL;
static FARPROC pApci8375GetErrorFlags = NULL;
static FARPROC pApci8375ReadStatusArea = NULL;
static FARPROC pApci8375WriteStatusArea = NULL;
static FARPROC pApci8375GetBS1AStatus = NULL;
static FARPROC pApci8375GetCommStatus = NULL;
static FARPROC pApci8375BankChange = NULL;
static FARPROC pApci8375GetLastError = NULL;

/*============================================================================
// 		apci8375.dll۰(۰ގʹװƂ)
// 		
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI8375_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci8375wGetDllExportFunc();
			if (TRUE != Result)
				Apci8375wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 		apci8375.dll۰(۰ގʹװƂ)
// 		
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 		aPCI-8375 DLL,޲ײންޮݏ擾
// 		pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//			pdwDriverVersion	޲ײންޮݔԍi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 		޲̎gp錾
// 		pwBsn	gp޲ BSN i[߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wCreate(PWORD pwBsn)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375Create)(pwBsn);
	return Result;
}
/*============================================================================
// 		o͑҂Ԃ̐ݒ
// 		wBsn		o͑҂Ԃݒ肷޲ BSN w
//			dwWaitTime	o͑҂ԂmSPʂŎw
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wSetWaitTime( WORD wBsn, DWORD dwWaitTime )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375SetWaitTime)(wBsn, dwWaitTime);
	return Result;
}
/*============================================================================
// 		o͂̐ݒ
// 		wBsn	o͂̐ݒ肷޲ BSN w
//			dwIOs	o͐ݒlw
//				o͐ݒl̊eޯĂS-LINKڽ͈ȉ̊֌WɂȂ܂B
//		  		  	Bit0	S-LINKڽ		  0 `  15
//		  		  	Bit1	S-LINKڽ		 16 `  31
//		  		  	Bit2	S-LINKڽ		 32 `  47
//		  		  	Bit3	S-LINKڽ		 48 `  63
//		  		  	Bit4	S-LINKڽ		 64 `  79
//		  		  	Bit5	S-LINKڽ		 80 `  95
//		  		  	Bit6	S-LINKڽ		 96 ` 111
//		  		  	Bit7	S-LINKڽ		112 ` 127
//		  		Bit8ȏ͖܂B
//		  		eBit'1'ĂƏóA'0'ĂƓ͂̐ݒƂȂ܂B
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wSetIOs( WORD wBsn, DWORD dwIOs )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375SetIOs)(wBsn, dwIOs);
	return Result;
}
/*============================================================================
// 		o͐ݒ̓ǂݏo
// 		wBsn	o͐ݒ̓ǂݏo޲ BSN w
//			pdwIOs	ǂݏoo͐ݒli[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetIOs( WORD wBsn, PDWORD pdwIOs )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetIOs)(wBsn, pdwIOs);
	return Result;
}
/*============================================================================
// 		Ѿ
// 		wBsn	ѾĂs޲ BSN w
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wSystemSet( WORD wBsn )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375SystemSet)(wBsn);
	return Result;
}
/*============================================================================
// 		S-LINK ́^oƯĂ̐ڑ䐔ƼѾĊ̊mF
// 		wBsn		ڑƯđ䐔̊mFs޲ BSN w
//			pdwUnits	ڑƯđ䐔i[̈ւ߲
//			pComplete	ѾĂ̊Ԃi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetTotalUnitNumber( WORD wBsn, PDWORD pdwUnits, PBOOL pComplete )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetTotalUnitNumber)(wBsn, pdwUnits, pComplete);
	return Result;
}
/*============================================================================
// 		S-LINK ́^o͓_̎擾
// 		wBsn		́^o͓_擾޲ BSN w
//			pdwLength	́^o͓_i[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wSystemAddressLength( WORD wBsn, PDWORD pdwLength )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375SystemAddressLength)(wBsn, pdwLength);
	return Result;
}
/*============================================================================
// 		 S-LINKڽiޯĒPʁjON/OFF̊mF
// 		wBsn		S-LINKڽON/OFFmF޲ BSN w
//			dwSlAddress	S-LINKڽiޯĒPʁjw
//			pStatus		wS-LINKڽON/OFFԂi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wInBit( WORD wBsn, DWORD dwSlAddress, PBOOL pStatus )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375InBit)(wBsn, dwSlAddress, pStatus);
	return Result;
}
/*============================================================================
// 		 S-LINKڽiޯĒPʁjON/OFF̐
// 		wBsn		S-LINKڽON/OFF𐧌䂷޲ BSN w
//			dwSlAddress	S-LINKڽiޯĒPʁjw
//			Status		wS-LINKڽON/OFFԂw
//			dwAction	o͌̓w
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wOutBit( WORD wBsn, DWORD dwSlAddress, BOOL Status, DWORD dwAction )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375OutBit)(wBsn, dwSlAddress, Status, dwAction);
	return Result;
}
/*============================================================================
// 		 S-LINK޲ıڽON/OFF̊mF
// 		wBsn		S-LINK޲ıڽON/OFFmF޲ BSN w
//			dwSlAddress	S-LINK޲ıڽw
//			pdwData		wS-LINK޲ıڽ޲ްi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wInByte( WORD wBsn, DWORD dwSlAddress, PDWORD pdwData )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375InByte)(wBsn, dwSlAddress, pdwData);
	return Result;
}
/*============================================================================
// 		 S-LINK޲ıڽON/OFF̐
// 		wBsn		S-LINK޲ıڽON/OFF𐧌䂷޲ BSN w
//			dwSlAddress	S-LINK޲ıڽw
//			dwData		wS-LINK޲ıڽON/OFFԂw
//			dwAction	o͌̓w
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wOutByte( WORD wBsn, DWORD dwSlAddress, DWORD dwData, DWORD dwAction )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375OutByte)(wBsn, dwSlAddress, dwData, dwAction);
	return Result;
}
/*============================================================================
// 		޲̉
// 		wBsn ޲ BSN w
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wClose( WORD wBsn )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375Close)(wBsn);
	return Result;
}
/*============================================================================
// 		װ׸ނ̏Ԃ擾
// 		wBsn			װ׸ނ̏Ԃ擾޲ BSN w
//			pdwFlags		װ׸ނ̏Ԃi[̈ւ߲
//			pdwERR4Units	ERR4̔䐔i[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetErrorFlags( WORD wBsn, PDWORD pdwFlags, PDWORD pdwERR4Units )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetErrorFlags)(wBsn, pdwFlags, pdwERR4Units);
	return Result;
}
/*============================================================================
// 		S-LINK ðر̓ǂݏo
// 		wBsn		S-LINK ðر̓ǂݏo޲ BSN w
//			dwLogPort	̘_߰Ĕԍ̓ǂݏos
//			pdwData		ǂݏoްi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wReadStatusArea( WORD wBsn, DWORD dwLogPort, PDWORD pdwData )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375ReadStatusArea)(wBsn, dwLogPort, pdwData);
	return Result;
}
/*============================================================================
// 		S-LINK ðرւ̏
// 		wBsn		S-LINK ðرւ݂̏s޲ BSN w
//			dwLogPort	̘_߰Ĕԍ݂̏s
//			dwData		ް
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wWriteStatusArea( WORD wBsn, DWORD dwLogPort, DWORD dwData )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375WriteStatusArea)(wBsn, dwLogPort, dwData);
	return Result;
}
/*============================================================================
// 		SL-BS1A̐ڑAԎ擾
// 		wBsn		SL-BS1A̓Ԃ擾޲ BSN w
//			dwAddress	Ԃ擾SL-BS1A̱ڽw肵܂B
//			pConnected	ڑԂi[̈ւ߲
//			pActive		Ԃi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetBS1AStatus( WORD wBsn, DWORD dwAddress, PBOOL pConnected, PBOOL pActive )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetBS1AStatus)(wBsn, dwAddress, pConnected, pActive);
	return Result;
}
/*============================================================================
// 		S-LINKʐMmF
// 		wBsn		ʐMmFs޲ BSN w
//			pStatus		ʐMԂi[̈ւ߲
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wGetCommStatus( WORD wBsn, PBOOL pStatus )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375GetCommStatus)(wBsn, pStatus);
	return Result;
}
/*============================================================================
// 		S-LINKݸ؂ւ
// 		wBsn	S-LINKݸ؂ւs޲ BSN w
//			dwBank	؂ւݸԍw
// ߂l	 TRUE
//			s FALSE
//==========================================================================*/
BOOL Apci8375wBankChange( WORD wBsn, DWORD dwBank )
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8375BankChange)(wBsn, dwBank);
	return Result;
}
/*============================================================================
// 		aPCI-8375̴װގ擾
// 		wBsn	װނ擾޲ BSN wB
// ߂l	װ
//==========================================================================*/
DWORD Apci8375wGetLastError( WORD wBsn )
{
	if (NULL == hDLL)
		return APCI8375_ERR_WRAPDLL;
	else
		return (*pApci8375GetLastError)(wBsn);
}
/*----------------------------------------------------------------------------
// 		DLL߰Ċ֐ڽ̎擾
// 		
// ߂l	 TRUE
//			s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci8375wGetDllExportFunc()
{
	/* Apci8375GetVersion ̱ڽ擾 */
	pApci8375GetVersion = GetProcAddress( hDLL, _T("Apci8375GetVersion"));
	if (pApci8375GetVersion == NULL)	return FALSE;
	/* Apci8375Create ̱ڽ擾 */
	pApci8375Create = GetProcAddress( hDLL, _T("Apci8375Create"));
	if (pApci8375Create == NULL)	return FALSE;
	/* Apci8375SetWaitTime ̱ڽ擾 */
	pApci8375SetWaitTime = GetProcAddress( hDLL, _T("Apci8375SetWaitTime"));
	if (pApci8375SetWaitTime == NULL)	return FALSE;
	/* Apci8375SetIOs ̱ڽ擾 */
	pApci8375SetIOs = GetProcAddress( hDLL, _T("Apci8375SetIOs"));
	if (pApci8375SetIOs == NULL)	return FALSE;
	/* Apci8375GetIOs ̱ڽ擾 */
	pApci8375GetIOs = GetProcAddress( hDLL, _T("Apci8375GetIOs"));
	if (pApci8375GetIOs == NULL)	return FALSE;
	/* Apci8375SystemSet ̱ڽ擾 */
	pApci8375SystemSet = GetProcAddress( hDLL, _T("Apci8375SystemSet"));
	if (pApci8375SystemSet == NULL)	return FALSE;
	/* Apci8375GetTotalUnitNumber ̱ڽ擾 */
	pApci8375GetTotalUnitNumber = GetProcAddress( hDLL, _T("Apci8375GetTotalUnitNumber"));
	if (pApci8375GetTotalUnitNumber == NULL)	return FALSE;
	/* Apci8375SystemAddressLength ̱ڽ擾 */
	pApci8375SystemAddressLength = GetProcAddress( hDLL, _T("Apci8375SystemAddressLength"));
	if (pApci8375SystemAddressLength == NULL)	return FALSE;
	/* Apci8375InBit ̱ڽ擾 */
	pApci8375InBit = GetProcAddress( hDLL, _T("Apci8375InBit"));
	if (pApci8375InBit == NULL)	return FALSE;
	/* Apci8375OutBit ̱ڽ擾 */
	pApci8375OutBit = GetProcAddress( hDLL, _T("Apci8375OutBit"));
	if (pApci8375OutBit == NULL)	return FALSE;
	/* Apci8375InByte ̱ڽ擾 */
	pApci8375InByte = GetProcAddress( hDLL, _T("Apci8375InByte"));
	if (pApci8375InByte == NULL)	return FALSE;
	/* Apci8375OutByte ̱ڽ擾 */
	pApci8375OutByte = GetProcAddress( hDLL, _T("Apci8375OutByte"));
	if (pApci8375OutByte == NULL)	return FALSE;
	/* Apci8375Close ̱ڽ擾 */
	pApci8375Close = GetProcAddress( hDLL, _T("Apci8375Close"));
	if (pApci8375Close == NULL)	return FALSE;
	/* Apci8375GetErrorFlags ̱ڽ擾 */
	pApci8375GetErrorFlags = GetProcAddress( hDLL, _T("Apci8375GetErrorFlags"));
	if (pApci8375GetErrorFlags == NULL)	return FALSE;
	/* Apci8375ReadStatusArea ̱ڽ擾 */
	pApci8375ReadStatusArea = GetProcAddress( hDLL, _T("Apci8375ReadStatusArea"));
	if (pApci8375ReadStatusArea == NULL)	return FALSE;
	/* Apci8375WriteStatusArea ̱ڽ擾 */
	pApci8375WriteStatusArea = GetProcAddress( hDLL, _T("Apci8375WriteStatusArea"));
	if (pApci8375WriteStatusArea == NULL)	return FALSE;
	/* Apci8375GetBS1AStatus ̱ڽ擾 */
	pApci8375GetBS1AStatus = GetProcAddress( hDLL, _T("Apci8375GetBS1AStatus"));
	if (pApci8375GetBS1AStatus == NULL)	return FALSE;
	/* Apci8375GetCommStatus ̱ڽ擾 */
	pApci8375GetCommStatus = GetProcAddress( hDLL, _T("Apci8375GetCommStatus"));
	if (pApci8375GetCommStatus == NULL)	return FALSE;
	/* Apci8375BankChange ̱ڽ擾 */
	pApci8375BankChange = GetProcAddress( hDLL, _T("Apci8375BankChange"));
	if (pApci8375BankChange == NULL)	return FALSE;
	/* Apci8375GetLastError ̱ڽ擾 */
	pApci8375GetLastError = GetProcAddress( hDLL, _T("Apci8375GetLastError"));
	if (pApci8375GetLastError == NULL)	return FALSE;
	/* SĂ DLL ߰Ċ֐ڽ擾nj */
	return TRUE;
}
